//+--------------------------------------------------------------------------------------------+
//|                                                                                 TMA EA.mq4 |
//|                                          Copyright  2007, Nick Bilak, beluck[AT]gmail.com |
//|                                         made for Kevin Boisvert <kevinb1914@earthlink.net> |
//|                                         modify by Serega Lykov, http://mtexperts.narod.ru/ |
//+--------------------------------------------------------------------------------------------+
// mod001 - Based on "WOW-exp mod004" (rework for trade by indicator "TmaSlope.v1.5 Normalized Lite")
// mod002 - rewrite the closing function, add parameters myMagic_CloseBy and UseCloseBy
// mod003 - fix error with StopLoss and TakeProfit4 at 5(3)-digits accounts
//        - fix error with using function CloseBy() at closing Sell-orders
// mod004 - fix error at option CloseAll (in case if does not exist position but exist pending order)
// mod005 - fix error at options StartTrail1 and StartTrail2

#property copyright "Copyright  2007, Nick Bilak"
#property link      "http://www.mql4.info/"

//---- constant values ------------------------------------------------------------------------+
#define IndicatorName_TMA               "TmaSlope.v1.5 Normalized Lite"

//---- external parameters --------------------------------------------------------------------+
   //---- parameters of indicator "TMA" -------------------------------------------------------+
extern int    TMA_eintPeriod                  = 5;     // parameter of indicator "TMA"
extern double TMA_edblHigh1                   = 1.75;   // parameter of indicator "TMA"
extern double TMA_edblLow1                    = -1.75;  // parameter of indicator "TMA"
extern int    TMA_atrPeriod                   = 10;    // parameter of indicator "TMA"

extern double TakeProfit4                     = 3;     // (amount pips)
extern double StopLoss                        = 3.0;   // (amount pips)
extern double MoveToBE                        = 2;     // (amount pips) profit before the stop loss level moves to opening price, 0 = does not move to BE (option is disabled)

extern double MaximumRisk                     = 25;    // % risk
extern bool   FixedLot                        = false; // set to false to claculate lot size 
extern double Lots                            = 1.0;   // fixed lot size 
extern int    OrdersStep                      = 0;     // (amount pips) Place stop order every 5 pips
extern int    PositionsNumber                 = 0;    // how many orders in the same direction; 1 = trade without grid

extern int    StartTrail1                     = 0;     // (amount pips)
extern int    TrailingStop1                   = 0;     // (amount pips); 0 = don't use T/S #1
extern int    StartTrail2                     = 0;    // (amount pips)
extern int    TrailingStop2                   = 0;     // (amount pips); 0 = don't use T/S #2

extern bool   PendingStopLimit                = true;  // true = ECN-broker, false = non-ECN-broker
extern bool   UseCloseBy                      = true;  // define method for close orders: true = open opposite order and close one order by other; false = close orders by current price
extern bool   CloseAll                        = false; // true = to close all positions, to delete all pending orders and don't open a new orders
extern bool   DeleteAll                       = false; // true = to delete all pending orders and don't open a new orders
extern bool   CloseOpenPositionsFirst         = false;  // false = immediately open new positions if TMA signals opposite direction
extern bool   CloseAllWhenRanging             = false; // false = do nothing when TMA is Ranging

extern int    TMAOffsetToOpen                 = 0;     // (amount pips) Offset in pips of TMA cross
extern int    TMAOffsetToClose                = 0;     // (amount pips) Offset in pips of TMA cross
extern double MoveToBE_Offset                 = 0;     // (amount pips) offset from the open price of order before new level stop loss is set, value > 0 = offset once in profit, value < 0 = offset if loss occurs
extern int    Slippage                        = 2;     // (amount pips) slippage for market order 
extern int    OrderTriesNumber                = 2;

extern bool   DoScreenShots                   = true;  // Makes screen shots when a trade is open
extern int    TakeProfit1                     = 0;     // (amount pips)
extern int    TakeProfit2                     = 0;     // (amount pips)
extern int    TakeProfit3                     = 0;     // (amount pips)
extern int    LotDigits                       = 1;
extern int    shift                           = 0;     // barshift of signal-bar
extern int    myMagic                         = 174;
extern int    myMagic_CloseBy                 = 175;
extern string EAName                          = "TMA_EA";

extern bool   SwapControl                     = false;
extern string exit_before_swap                = "23:58";
extern string resume_after_swap               = "00:05";

extern string sm0                             = "--Trading Hours Filter--";
extern string sm2                             = "UseTradingHours - Enter 0 for false, 1 for true";
extern int    UseTradingHours                 = 0;
extern string sm3                             = "Trade Session 1 - Enter 0 for false, 1 for true";
extern int    TradeSession1                   = 1;
extern int    Session1Start                   = 2200;  // Start trades after time
extern int    Session1Stop                    = 400;   // Stop trading after time
extern string sm4                             = "Trade Session 2 - Enter 0 for false, 1 for true";
extern int    TradeSession2                   = 1;
extern int    Session2Start                   = 400;   // Start trades after time
extern int    Session2Stop                    = 700;   // Stop trading after time
extern string sm5                             = "Trade Session 3 - Enter 0 for false, 1 for true";
extern int    TradeSession3                   = 1;
extern int    Session3Start                   = 700;   // Start trades after time
extern int    Session3Stop                    = 900;   // Stop trading after time
extern string sm6                             = "Trade Session 4 - Enter 0 for false, 1 for true";
extern int    TradeSession4                   = 1;
extern int    Session4Start                   = 900;   // Start trades after time
extern int    Session4Stop                    = 1500;  // Stop trading after time
extern string sm7                             = "Trade Session 5 - Enter 0 for false, 1 for true";
extern int    TradeSession5                   = 1;
extern int    Session5Start                   = 1500;  // Start trades after time
extern int    Session5Stop                    = 2200;  // Stop trading after time
extern string ____TMA_______________          = "---------------------------------------------";

   //---- others parameters -------------------------------------------------------------------+
extern string _____Others___________          = "---------------------------------------------";
extern color  ColorBuy                        = Blue;  // color arrows of Buy-orders
extern color  ColorSell                       = Red;   // color arrows of Sell-orders

//----- global variables ----------------------------------------------------------------------+
static bool     buysig;
static bool     sellsig;
static bool     closebuy;
static bool     closesell; 
static int      it;
static int      lastsig;
static int      tries;
static int      buys;
static int      sells;
static int      long;
static int      short;
static int      longorder;
static int      shortorder;
static datetime xtime;
static datetime ttime;
static double   cross_price;
static double   longsize;
static double   shortsize;
static double   hb;
static double   ls;
static string   gvtp1;
static string   gvtp2;
static string   gvtp3;
static bool     nlma_long;
static bool     nlma_short;
static int      tma_val;
static int      prev_tma_val;
static int      last_alert_trend = 0;
static double   tma_offset_open;
static double   tma_offset_close;
static bool     use_partial_closing;
static double   be_profit;
static double   be_offset;
static double   point;
static int      digits;
static string   symbol;
static double   num_levels_tp;
static double   main_sl;
static double   main_tp;
static double   tp_1;
static double   tp_2;
static double   tp_3;
static double   ts_start_1;
static double   ts_dist_1;
static double   ts_start_2;
static double   ts_dist_2;
static double   orders_step;
static int      slippage;
static int      pips_digits;
static int      correction;
static int      lots_digits;
static double   maxlots;
static double   minlots;
static double   lotstep;
static double   sl_corr;

//---------------------------------------------------------------------------------------------+
//---- init -----------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int init()
  {
   symbol = Symbol();
   maxlots = MarketInfo(symbol,MODE_MAXLOT);
   minlots = MarketInfo(symbol,MODE_MINLOT);
   lotstep = MarketInfo(symbol,MODE_LOTSTEP);
   if(lotstep == 0.01) lots_digits = 2;
   else if(lotstep == 0.1) lots_digits = 1;
        else if(lotstep == 1) lots_digits = 0;
             else if(lotstep == 0.001) lots_digits = 3;
                  else lots_digits = 4;
   if(Digits < 4)
     {
      point = 0.01;
      digits = 2;
     }
   else
     {
      point = 0.0001;
      digits = 4;
     }
   pips_digits = Digits - digits;
   correction = MathPow(10,pips_digits);
   slippage = Slippage * correction;
   sl_corr = StopLoss * correction;
   main_sl = NormalizeDouble((-1.0) * StopLoss * point,Digits);
   tp_1 = NormalizeDouble(TakeProfit1 * point,Digits);
   tp_2 = NormalizeDouble(TakeProfit2 * point,Digits);
   tp_3 = NormalizeDouble(TakeProfit3 * point,Digits);
   main_tp = NormalizeDouble(TakeProfit4 * point,Digits);
   ts_start_1 = NormalizeDouble(StartTrail1 * point,Digits);
   ts_dist_1  = NormalizeDouble(TrailingStop1 * point,Digits);
   ts_start_2 = NormalizeDouble(StartTrail2 * point,Digits);
   ts_dist_2  = NormalizeDouble(TrailingStop2 * point,Digits);
   be_profit = NormalizeDouble(MoveToBE * point,Digits);
   be_offset = NormalizeDouble(MoveToBE_Offset * point,Digits);
   tma_offset_open  = NormalizeDouble(TMAOffsetToOpen * Point, Digits);
   tma_offset_close = NormalizeDouble(TMAOffsetToClose * Point,Digits);
   orders_step = NormalizeDouble(OrdersStep * point,Digits);
   use_partial_closing = TakeProfit1 > 0 || TakeProfit2 > 0 || TakeProfit3 > 0;
   num_levels_tp = 1.0;
   if(TakeProfit1 > 0) num_levels_tp += 1.0;
   if(TakeProfit2 > 0) num_levels_tp += 1.0;
   if(TakeProfit3 > 0) num_levels_tp += 1.0;
   gvtp1 = EAName + myMagic + symbol + Period() + "tp1";
   gvtp2 = EAName + myMagic + symbol + Period() + "tp2";
   gvtp3 = EAName + myMagic + symbol + Period() + "tp3";
  }

//---------------------------------------------------------------------------------------------+
//---- deinit ---------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }

//---------------------------------------------------------------------------------------------+
//---- deinit ---------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int start()
  {
   if(Bars < 100 || !IsTradeAllowed()) return(0);
   //----     ---------------------------------------------+
   WatchCloseBy(myMagic,myMagic_CloseBy);
   //----    ----------------------------------------------------------+
   Run();
   //----     ----------------------------------------------+
   if(use_partial_closing) Profits();
   //----    ------------------------------------------------------------------+
   if(TakeProfit4 > 0.0 || StopLoss > 0.0)
     {
      SetOrderLevels(main_tp,main_sl,myMagic);
      WatchOrderLevels(main_tp,main_sl,myMagic);
     }
   if(MoveToBE > 0.0) WatchMoveSLToBE(be_profit,be_offset,myMagic);
   if(TrailingStop1 > 0) TrailStop(ts_start_1,ts_dist_1);
   if(TrailingStop2 > 0) TrailStop(ts_start_2,ts_dist_2);
   return(0);
  }

//---------------------------------------------------------------------------------------------+
//---- Run ------------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void Run()
  {
   //----    ----------------------------------------------------------+
   int co = CalculateCurrentOrders();
   //----            ------------+
   if(shift == 0 || it != Time[0])
     {
      it = Time[0];
      GetIndicatorSignal(tma_val,prev_tma_val,shift);
     }
   //----     ------------------------------------------+
   nlma_long  = tma_val > 0;
   nlma_short = tma_val < 0;
   bool nlma_long_x  = prev_tma_val > 0;
   bool nlma_short_x = prev_tma_val < 0;
   //----        ------------------------------------+
   if(nlma_long_x || nlma_short_x)
     {
      cross_price = NormalizeDouble(Close[shift],Digits);
      xtime       = Time[0];
     }
   //----       --------------------------------------------+
   double close = NormalizeDouble(Close[0],Digits);
   buysig  = (nlma_long  && close >= NormalizeDouble(cross_price + tma_offset_open,Digits) && cross_price > 0) || (cross_price <= 0 && nlma_long);
   sellsig = (nlma_short && close <= NormalizeDouble(cross_price - tma_offset_open,Digits) && cross_price > 0) || (cross_price <= 0 && nlma_short);
   closebuy  = sellsig;
   closesell = buysig;
   //----    ------------------------------------------------------+
   if(!nlma_long)
     {
      if(!nlma_short) string cm = "NO TREND";
      else cm = "TRENDING DOWN";
     }
   else
     {
      if(!nlma_short) cm = "TRENDING UP";
      else cm = "TRENDING UP&DOWN";
     }
   Comment(cm);
   //----    swap -----------------------------------------------------+
   if(SwapControl)
     {
      if(nlma_long > 0 && MarketInfo(symbol,MODE_SWAPLONG) < 0 && TimeCurrent() > StrToTime(exit_before_swap))
        {
         closebuy = true;
         buysig   = false;
         if(long > 0)
           {
	         MakeScreenShot(" buy close SWAP (pre)");
            CheckForClose();
	         MakeScreenShot(" buy close SWAP");
	        }
	     }
      if(nlma_long > 0 && MarketInfo(symbol,MODE_SWAPLONG) < 0 && TimeCurrent() < StrToTime(resume_after_swap)) buysig = false;
      if(nlma_short > 0 && MarketInfo(symbol,MODE_SWAPSHORT) < 0 && TimeCurrent() > StrToTime(exit_before_swap))
        {
         closesell = true;
         sellsig   = false;
         if(short > 0)
           {
	         MakeScreenShot(" sell close SWAP (pre)");
            CheckForClose();
	         MakeScreenShot(" sell close SWAP");
	        }
	     }
      if(nlma_short > 0 && MarketInfo(symbol,MODE_SWAPSHORT) < 0 && TimeCurrent() < StrToTime(resume_after_swap)) sellsig = false;
     }
   //----   ,   ------------------------------------------------+
   if(CloseAll)
     {
      closebuy  = true;
      closesell = true;
      CheckForClose();
      CloseOrders(-3,myMagic);
      return;
     }
   if(DeleteAll)
     {
      CloseOrders(-3,myMagic);
      return;
     }
   //----    ,   --------------------------------------------------+
   if(CheckTradingTimes()) return;
   //----    ----------------------------------------------------------+
   if(CloseOpenPositionsFirst)
     {
      WatchClosingSignal();
      WatchOpeningSignal(false);
     }
   else
     {
      WatchOpeningSignal(true);
      WatchClosingSignal();
     }
   //----     --------------------------------------------------+
   if(PositionsNumber > 1) OpenPending();
  }

//---------------------------------------------------------------------------------------------+
//---- WatchClosingSignal ---------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void WatchClosingSignal()
  {
   //----     ------------------------------------------------------+
   int co = CalculateCurrentOrders();
   double close = NormalizeDouble(Close[0],Digits);
   if((long > 0 || longorder > 0) && (closebuy || (nlma_short && close <= NormalizeDouble(cross_price - tma_offset_close,Digits) && cross_price > 0) || (CloseAllWhenRanging && tma_val == 0)))
     {
      closebuy = true;
	   MakeScreenShot(" buy close (pre)");
      CheckForClose();
	   MakeScreenShot(" buy close");
     }
   if((short > 0 || shortorder > 0) && (closesell || (nlma_long && close >= NormalizeDouble(cross_price + tma_offset_close,Digits) && cross_price > 0) || (CloseAllWhenRanging && tma_val == 0)))
     {
      closesell = true;
	   MakeScreenShot(" sell close (pre)");
      CheckForClose();
	   MakeScreenShot(" sell close");
     }
  }

//---------------------------------------------------------------------------------------------+
//---- WatchOpeningSignal ---------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void WatchOpeningSignal(bool overlay)
  {
   //----   ,       GV ---------------------------+
   int co = CalculateCurrentOrders();
   if(co == 0)
     {
      buys  = 0;
      sells = 0;
      GlobalVariableDel(gvtp1);
      GlobalVariableDel(gvtp2);
      GlobalVariableDel(gvtp3);
     }
   //----     ------------------------------------------------------+
   double close = NormalizeDouble(Close[0],Digits);
   if(buys == 0 && buysig)
     {
	   MakeScreenShot(" buy open (pre)");
	   if(!overlay) double add_lots = 0.0;
	   else add_lots = shortsize;
      int res = OpenAtMarket(OP_BUY,LotsRisk(sl_corr)*num_levels_tp+add_lots,StopLoss,TakeProfit4,"");
      if(res > 0) ttime = xtime;
	   MakeScreenShot(" buy open");
     }
   if(sells == 0 && sellsig)
     {
	   MakeScreenShot(" sell open (pre)");
	   if(!overlay) add_lots = 0.0;
	   else add_lots = longsize;
      res = OpenAtMarket(OP_SELL,LotsRisk(sl_corr)*num_levels_tp+add_lots,StopLoss,TakeProfit4,"");
      if(res > 0) ttime = xtime;
	   MakeScreenShot(" sell open");
     }
  }

//---------------------------------------------------------------------------------------------+
//---- CalculateCurrentOrders -----------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int CalculateCurrentOrders()
  {
   int ord = 0;
   long  = 0;
   short = 0;
   longsize  = 0.0;
   shortsize = 0.0;
   longorder  = 0;
   shortorder = 0;
   hb = 0.0;
   ls = 9999.0;
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if(OrderSymbol() == symbol && OrderMagicNumber() == myMagic)
        {
         ord++;
         if(OrderType() == OP_BUY)
           {
            long++;
            longsize += OrderLots();
            hb = MathMax(hb,OrderOpenPrice());
           }
         else
           {
            if(OrderType() == OP_SELL)
              {
               short++;
               shortsize += OrderLots();
               ls = MathMin(ls,OrderOpenPrice());
              }
            else
              {
               if(OrderType() == OP_BUYSTOP) longorder++;
               else if(OrderType() == OP_SELLSTOP) shortorder++;
              }
           }
        }
     }
   return(ord);
  }

//---------------------------------------------------------------------------------------------+
//---- Profits --------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void Profits()
  {
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if(OrderMagicNumber() != myMagic) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      if(order_type == OP_BUY)
        {
         double profit = NormalizeDouble(OrderClosePrice() - OrderOpenPrice(),Digits);
         color order_color = ColorBuy;
        }
      else
        {
         profit = NormalizeDouble(OrderOpenPrice() - OrderClosePrice(),Digits);
         order_color = ColorSell;
        }
      if(TakeProfit1 > 0 && profit >= tp_1 && GlobalVariableGet(gvtp1) < 1)
        {
         bool bres = OrderCloseEx(OrderTicket(),NormalizeDouble(OrderLots()/(num_levels_tp - GetNumClosedParts()),LotDigits),OrderClosePrice(),slippage,order_color,"PartialClose_1");
		   if(bres) GlobalVariableSet(gvtp1,1);
        }
      if(TakeProfit2 > 0 && profit >= tp_2 && GlobalVariableGet(gvtp2) < 1)
        {
         bres = OrderCloseEx(OrderTicket(),NormalizeDouble(OrderLots()/(num_levels_tp - GetNumClosedParts()),LotDigits),OrderClosePrice(),slippage,order_color,"PartialClose_2");
		   if(bres) GlobalVariableSet(gvtp2,1);
        }
      if(TakeProfit3 > 0 && profit >= tp_3 && GlobalVariableGet(gvtp3) < 1)
        {
         bres = OrderCloseEx(OrderTicket(),NormalizeDouble(OrderLots()/(num_levels_tp - GetNumClosedParts()),LotDigits),OrderClosePrice(),slippage,order_color,"PartialClose_3");
		   if(bres) GlobalVariableSet(gvtp3,1);
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- GetNumClosedParts ----------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int GetNumClosedParts()
  {
   int num_closed_parts = 0;
   if(GlobalVariableGet(gvtp1) == 1) num_closed_parts++;
   if(GlobalVariableGet(gvtp2) == 1) num_closed_parts++;
   if(GlobalVariableGet(gvtp3) == 1) num_closed_parts++;
   return(num_closed_parts);
  }

//---------------------------------------------------------------------------------------------+
//---- TrailStop ------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void TrailStop(double ts_start, double ts_dist)
  {
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if(OrderMagicNumber() != myMagic) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  Digits);
      if(order_type == OP_BUY)
        {
         if(ts_start > 0.0) if(ts_start > NormalizeDouble(order_close_price - order_open_price,Digits)) continue;
         double new_sl = NormalizeDouble(order_close_price - ts_dist,Digits);
         if(new_sl >= NormalizeDouble(order_stop_loss + Point,Digits)) OrderModifyEx(OrderTicket(),order_open_price,new_sl,OrderTakeProfit(),0,Gold,"TrailStop");
        }
      else
        {
         if(ts_start > 0.0) if(ts_start > NormalizeDouble(order_open_price - order_close_price,Digits)) continue;
         new_sl = NormalizeDouble(order_close_price + ts_dist,Digits);
         if(new_sl <= NormalizeDouble(order_stop_loss - Point,Digits) || order_stop_loss == 0.0) OrderModifyEx(OrderTicket(),OrderOpenPrice(),new_sl,OrderTakeProfit(),0,Gold,"TrailStop");
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- CheckForClose --------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void CheckForClose()
  {
   //----    ----------------------------------------------------------+
   CalculateCurrentOrders();
   //----    Buy   Buy- -------------------------------------------+
   if(closebuy && long > 0)
     {
      //----    --------------------------------------------------------+
      CloseOrders(OP_BUYSTOP,myMagic);
      //----    -------------------------------------------------------+
      if(!UseCloseBy) CloseOrders(OP_BUY,myMagic);
      //----      --------------------------------+
      else
        {
         double closeby_lots = NormalizeDouble(longsize - GetOpenedLots(OP_SELL,myMagic_CloseBy),lots_digits);
         if(closeby_lots > 0.0) OrderSendEx(symbol,OP_SELL,closeby_lots,0.0,slippage,0.0,0.0,StringConcatenate("clby_",EAName,"_",DoubleToStr(myMagic,0)),myMagic_CloseBy,0,ColorSell);
         //----    --------------------------------------------------+
         WatchCloseBy(myMagic,myMagic_CloseBy);
        }
     }
   //----    Sell   Sell- -----------------------------------------+
   if(closesell && short > 0)
     {
      //----    --------------------------------------------------------+
      CloseOrders(OP_SELLSTOP,myMagic);
      //----    -------------------------------------------------------+
      if(!UseCloseBy) CloseOrders(OP_SELL,myMagic);
      //----      --------------------------------+
      else
        {
         closeby_lots = NormalizeDouble(shortsize - GetOpenedLots(OP_BUY,myMagic_CloseBy),lots_digits);
         if(closeby_lots > 0.0) OrderSendEx(symbol,OP_BUY,closeby_lots,0.0,slippage,0.0,0.0,StringConcatenate("clby_",EAName,"_",DoubleToStr(myMagic,0)),myMagic_CloseBy,0,ColorBuy);
         //----    --------------------------------------------------+
         WatchCloseBy(myMagic,myMagic_CloseBy);
        }
     }
  }

double LotsRisk(double sl_corr)  { 
   double lot=Lots;
   if (sl_corr==0.0) sl_corr=100.0 * correction;
//---- select lot size
   if (!FixedLot)
      lot=AccountFreeMargin()*MaximumRisk*0.001/sl_corr;
   lot=NormalizeDouble(lot,LotDigits);
//---- return lot size
   if(lot<MarketInfo(symbol,MODE_MINLOT)) lot=MarketInfo(symbol,MODE_MINLOT);
   return(lot);
}

int OpenAtMarket(int mode,double lot, double SL, double TP, string cmt) {
   int    res,tr,col,pi;
   bool mres;
   double openprice,sl,tp,psl,ptp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELL) {
         openprice=Bid; 
         if (SL>0.0) psl=openprice-main_sl;
         if (TP>0.0) ptp=openprice-main_tp;
         if (!PendingStopLimit && SL>0.0) sl=openprice-main_sl;
         if (!PendingStopLimit && TP>0.0) tp=openprice-main_tp;
         col=ColorSell;
      } else {
         openprice=Ask;
         if (SL>0) psl=openprice+main_sl;
         if (TP>0) ptp=openprice+main_tp;
         if (!PendingStopLimit && SL>0.0) sl=openprice+main_sl;
         if (!PendingStopLimit && TP>0.0) tp=openprice+main_tp;
         col=ColorBuy;
      }
      Print("market:: ",symbol,"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ",cmt+"_"+EAName+"_"+myMagic);
      res=OrderSendEx(symbol,mode,lot,openprice,slippage,sl,tp,cmt+"_"+EAName+"_"+myMagic,myMagic,0,col);
      tries++;
   }
   if (res>0 && PendingStopLimit && (SL>0 || TP>0)) {
      //modify sl and tp
      pi=0; mres=false;
      Print("SL/TP mod : ",res," ",OrderOpenPrice()," ",psl," ",ptp," ",OrderExpiration()," ",col);
      while (!mres && pi<10) {
         pi++;
         if (OrderSelect(res,SELECT_BY_TICKET,MODE_TRADES))
            mres=OrderModifyEx(res,OrderOpenPrice(),psl,ptp,OrderExpiration(),col,"OpenAtMarket");
         Sleep(2000);
      }
   }
   if (res>0) 
   {
      if (mode==OP_BUY) buys++;
      if (mode==OP_SELL) sells++;
   }
   return(res);
}
  
int OpenPending() {
   int res;
   int co=CalculateCurrentOrders();
   //Comment("long=",long,"  short=",short," longorder=",longorder," shortorder",shortorder," PositionsNumber",PositionsNumber);
   if (!closebuy && nlma_long && long>0 && longorder==0 && buys<PositionsNumber) {
	   res = OpenOrder(OP_BUYSTOP,LotsRisk(sl_corr)*num_levels_tp,NormalizeDouble(hb + orders_step,Digits),StopLoss,TakeProfit4,"pnd");
      if (res>0) buys++;
	}
   if (!closesell && nlma_short && short>0 && shortorder==0 && sells<PositionsNumber) {
	   res = OpenOrder(OP_SELLSTOP,LotsRisk(sl_corr)*num_levels_tp,NormalizeDouble(ls - orders_step,Digits),StopLoss,TakeProfit4,"pnd");
      if (res>0) sells++;
   }
	return(res);
}

int OpenOrder(int mode,double lot, double prc, double SL, double TP, string cmt)
  {
   int    res,tr,col;
   double openprice,sl,tp,stlev=MarketInfo(symbol,MODE_STOPLEVEL)*Point;
   tries = 0;
   while(res<=0 && tries<OrderTriesNumber)
     {
      tr=0;
      while(tr<5 && !IsTradeAllowed())
        {
         tr++;
         Sleep(2000);
        }
      RefreshRates();
      if(mode==OP_SELLSTOP)
        {
         openprice=prc;
         if(openprice>Bid-stlev)
           {
            Print("pending err stoplevel :: ",stlev,"  ",symbol,"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ",cmt+"_"+EAName+"_"+myMagic);
            return; //openprice=Bid-stlev;
           }
         if(SL>0.0) sl=openprice-main_sl;
         if(TP>0.0) tp=openprice-main_tp;
         col=ColorSell;
        }
      else
        {
         openprice=prc;
         if(openprice<Ask+stlev)
           {
            Print("pending err stoplevel :: ",stlev,"  ",symbol,"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ",cmt+"_"+EAName+"_"+myMagic);
            return; //openprice=Bid-stlev;
           }
         if(SL>0) sl=openprice+main_sl;
         if(TP>0) tp=openprice+main_tp;
         col=ColorBuy;
        }
      Print("pending:: ",symbol,"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ",cmt+"_"+EAName+"_"+myMagic);
      res=OrderSendEx(symbol,mode,lot,openprice,slippage,sl,tp,cmt+"_"+EAName+"_"+myMagic,myMagic,0,col);
      tries++;
     }
   return(res);
  }

void MakeScreenShot(string sx=""){
   if (!DoScreenShots) return;
   //if (!DoScreenShots || IsTesting()) return;
   static int no=0;
   no++;
   string fn = WindowExpertName()+symbol+"\\"
               +Year()+"-"+al0(Month(),2)+"-"+al0(Day(),2)+" "+
               al0(Hour(),2)+"_"+al0(Minute(),2)+"_"+al0(Seconds(),2)+" "+no+sx+".gif";
       //Print(fn);
   if(!WindowScreenShot(fn,640,480)) Print("ScreenShot error: ", ErrorDescription(GetLastError()));
}

string al0(int number, int digits){
  // add leading zeros that the resulting string has 'digits' length.
  string result;
  result = DoubleToStr(number, 0);
  while(StringLen(result)<digits) result = "0"+result;
  return(result);
}


// Return true if time is not in session for trading
bool CheckOutsideSession(int SessionStart, int SessionStop, int ct)
{

   if (SessionStart < SessionStop)
   {
     if (ct >= SessionStart && ct <= SessionStop) return (false); else return(true);
   }
   else
   {
      if (ct > SessionStop && ct < SessionStart) return (true); else return(false);
   }
}

bool CheckTradingTimes()
{  
   if (UseTradingHours==0) return(false);
   bool StopTrading;
   int ct;
   ct = Hour() * 100 + Minute();
   
     StopTrading = true;

     if (TradeSession1 == 1)
     {
        StopTrading = CheckOutsideSession(Session1Start, Session1Stop, ct);
     }
     if (StopTrading == true)
     {

       if (TradeSession2 == 1)
       {
         StopTrading = CheckOutsideSession(Session2Start, Session2Stop, ct);
       }
     }
     if (StopTrading == true)
     {

       if (TradeSession3 == 1)
       {
         StopTrading = CheckOutsideSession(Session3Start, Session3Stop, ct);
       }
     }
     if (StopTrading == true)
     {

       if (TradeSession4 == 1)
       {
         StopTrading = CheckOutsideSession(Session4Start, Session4Stop, ct);
       }
     }
     if (StopTrading == true)
     {

       if (TradeSession5 == 1)
       {
         StopTrading = CheckOutsideSession(Session5Start, Session5Stop, ct);
       }
     }
     
     return(StopTrading);
}

//---------------------------------------------------------------------------------------------+
//---- ErrorDescription -----------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   switch(error_code)
     {
      case 0:
      case 1:    string error_string="no error";                                          break;
      case 2:    error_string="common error";                                             break;
      case 3:    error_string="invalid trade parameters";                                 break;
      case 4:    error_string="trade server is busy";                                     break;
      case 5:    error_string="old version of the client terminal";                       break;
      case 6:    error_string="no connection with trade server";                          break;
      case 7:    error_string="not enough rights";                                        break;
      case 8:    error_string="too frequent requests";                                    break;
      case 9:    error_string="malfunctional trade operation (never returned error)";     break;
      case 64:   error_string="account disabled";                                         break;
      case 65:   error_string="invalid account";                                          break;
      case 128:  error_string="trade timeout";                                            break;
      case 129:  error_string="invalid price";                                            break;
      case 130:  error_string="invalid stops";                                            break;
      case 131:  error_string="invalid trade volume";                                     break;
      case 132:  error_string="market is closed";                                         break;
      case 133:  error_string="trade is disabled";                                        break;
      case 134:  error_string="not enough money";                                         break;
      case 135:  error_string="price changed";                                            break;
      case 136:  error_string="off quotes";                                               break;
      case 137:  error_string="broker is busy (never returned error)";                    break;
      case 138:  error_string="requote";                                                  break;
      case 139:  error_string="order is locked";                                          break;
      case 140:  error_string="long positions only allowed";                              break;
      case 141:  error_string="too many requests";                                        break;
      case 145:  error_string="modification denied because order too close to market";    break;
      case 146:  error_string="trade context is busy";                                    break;
      case 147:  error_string="expirations are denied by broker";                         break;
      case 148:  error_string="amount of open and pending orders has reached the limit";  break;
      case 149:  error_string="hedging is prohibited";                                    break;
      case 150:  error_string="prohibited by FIFO rules";                                 break;
      case 4000: error_string="no error (never generated code)";                          break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed in the expert properties";            break;
      case 4110: error_string="longs are not allowed in the expert properties";           break;
      case 4111: error_string="shorts are not allowed in the expert properties";          break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
   return(error_string);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderTypeToStr -------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string OrderTypeToStr(int order_type)
  {
   switch(order_type)
     {
      case OP_BUY: string result = "Buy";       break;
      case OP_SELL:       result = "Sell";      break;
      case OP_BUYLIMIT:   result = "BuyLimit";  break;
      case OP_SELLLIMIT:  result = "SellLimit"; break;
      case OP_BUYSTOP:    result = "BuyStop";   break;
      case OP_SELLSTOP:   result = "SellStop";  break;
      default:            result = "Unknown";   break;
     }
   return(result);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderSendEx ----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int OrderSendEx(string order_symbol, int order_type, double order_lots, double order_open_price, int order_slippage, double order_stop_loss, double order_take_profit, string order_comment = "", int order_magic_number = 0, datetime order_expiration = 0, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_send        3
#define number_attempts_send_select 3
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   int err_129  = 0;
   int err_130  = 0;
   int err_137  = 0;
   int err_138  = 0;
   int err_4107 = 0;
   if(order_symbol == "" || order_symbol == "0") order_symbol = symbol;
   int order_digits  = MarketInfo(order_symbol,MODE_DIGITS);
   order_open_price  = NormalizeDouble(order_open_price,order_digits);
   order_stop_loss   = NormalizeDouble(order_stop_loss,order_digits);
   order_take_profit = NormalizeDouble(order_take_profit,order_digits);
   while(true)
     {
      if(!IsExpertEnabled())
        {
         int ticket = -1;
         break;
        }
      RefreshRates();
      double ask = NormalizeDouble(MarketInfo(order_symbol,MODE_ASK),order_digits);
      double bid = NormalizeDouble(MarketInfo(order_symbol,MODE_BID),order_digits);
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL)*MarketInfo(order_symbol,MODE_POINT),order_digits);
      if(order_type > OP_SELL)
        {
         if(order_open_price <= 0.0)
           {
            ticket = -1;
            break;
           }
         if((order_type % 2) == OP_BUY) double current_price = ask;
         else current_price = bid;
         switch(order_type)
           {
            case OP_BUYLIMIT:
            case OP_SELLSTOP:
               double distance = NormalizeDouble(current_price - order_open_price,order_digits);
               break;
            case OP_BUYSTOP:
            case OP_SELLLIMIT:
               distance = NormalizeDouble(order_open_price - current_price,order_digits);
               break;
           }
         if(distance < stoplevel)
           {
            if(distance < 0) Print(StringConcatenate(parent_fun_name,"OrderSendEx: The position of open price order does not correspond to type of the order."));
            else Print(StringConcatenate(parent_fun_name,"OrderSendEx: It is impossible to open the order (the open price is near to the current price)."));
            ticket = -1;
            break;
           }
         if(order_slippage < 0) order_slippage = 0;
        }
      else
        {
         if(order_type == OP_BUY)
           {
            if(order_open_price <= 0.0) order_open_price = ask;
           }
         else
           {
            if(order_open_price <= 0.0) order_open_price = bid;
           }
         if(order_slippage < 0) order_slippage = slippage;
        }
      if(order_stop_loss != 0)
        {
         if((order_type % 2) == OP_BUY) distance = NormalizeDouble(order_open_price - order_stop_loss,order_digits);
         else distance = NormalizeDouble(order_stop_loss - order_open_price,order_digits);
         if(distance < stoplevel)
           {
            if(distance < 0) Print(StringConcatenate(parent_fun_name,"OrderSendEx: The position of stop-loss price order does not correspond to type of the order."));
            else Print(StringConcatenate(parent_fun_name,"OrderSendEx: It is impossible to open the order (stop-loss is near to the open price)."));
            ticket = -1;
            break;
           }
        }
      if(order_take_profit != 0)
        {
         if((order_type % 2) == OP_BUY) distance = NormalizeDouble(order_take_profit - order_open_price,order_digits);
         else distance = NormalizeDouble(order_open_price - order_take_profit,order_digits);
         if(distance < stoplevel)
           {
            if(distance < 0) Print(StringConcatenate(parent_fun_name,"OrderSendEx: The position of take-profit price order does not correspond to type of the order."));
            else Print(StringConcatenate(parent_fun_name,"OrderSendEx: It is impossible to open the order (take-profit is near to the open price)."));
            ticket = -1;
            break;
           }
        }
      while(IsTradeContextBusy()) Sleep(1000);
      GetLastError();
      ticket = OrderSend(order_symbol,order_type,order_lots,order_open_price,order_slippage,order_stop_loss,order_take_profit,order_comment,order_magic_number,order_expiration,order_color);
      if(ticket < 0)
        {
         int err = GetLastError();
         Print(StringConcatenate(parent_fun_name,"OrderSendEx: OrderSend(",OrderTypeToStr(order_type),") ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_send) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_send) cont = true;
               break;
            case  134:
               Sleep(6000);
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_send) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_send) cont = true;
               break;
            case  140:
               if((order_type % 2) == OP_BUY)  cont = true;
               break;
            case  142:
               Sleep(70000);
               break;
            case  143:
               Sleep(70000);
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case  147:
               order_expiration = 0;
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               break;
            case 4107:
               err_4107++;
               if(err_4107 <= number_attempts_send) cont = true;
               break;
            case 4110:
               if((order_type % 2) == OP_SELL)  cont = true;
               break;
            case 4111:
               if((order_type % 2) == OP_BUY)  cont = true;
               break;
           }
         if(!cont) break;
        }
      else break;
     }
   return(ticket);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderModifyEx --------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool OrderModifyEx(int order_ticket, double new_open_price, double new_stop_loss, double new_take_profit, datetime new_expiration = -1, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_modify        3
#define number_attempts_modify_select 3
#define number_attempts_modify_wait   30
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   int err_129 = 0;
   int err_130 = 0;
   int err_137 = 0;
   int err_138 = 0;
   int err_145 = 0;
   while(true)
     {
      if(!IsExpertEnabled())
        {
         bool error = false;
         break;
        }
      RefreshRates();
      int counter_attempts_select = 0;
      while(counter_attempts_select < number_attempts_modify_select)
        {
         if(OrderSelect(order_ticket,SELECT_BY_TICKET)) break;
         Print(StringConcatenate(parent_fun_name,"OrderModifyEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
         Sleep(1000);
         counter_attempts_select++;
        }
      if(counter_attempts_select >= number_attempts_modify_select)
        {
         error = false;
         break;
        }
      if(OrderCloseTime() != 0) 
        {
         error = true;
         break;
        }
      string order_symbol = OrderSymbol();
      int order_type = OrderType();
      int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
      new_open_price  = NormalizeDouble(new_open_price, order_digits);
      new_stop_loss   = NormalizeDouble(new_stop_loss,  order_digits);
      new_take_profit = NormalizeDouble(new_take_profit,order_digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
      datetime order_expiration = OrderExpiration();
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL)*MarketInfo(order_symbol,MODE_POINT),order_digits);
      bool to_modify = false;
      if(order_type > OP_SELL)
        {
         if(new_open_price < 0 || new_open_price == order_open_price)
           {
            double modify_open_price = order_open_price;
            if(NormalizeDouble(MathAbs(modify_open_price - order_close_price),order_digits) < stoplevel)
              {
               error = false;
               break;
              }
           }
         else
           {
            modify_open_price = new_open_price;
            to_modify = true;
            bool to_modify2 = true;
            switch(order_type)
              {
               case OP_BUYLIMIT:
               case OP_SELLSTOP:
                  if(NormalizeDouble(order_close_price - modify_open_price,order_digits) < stoplevel) to_modify2 = false;
                  break;
               case OP_BUYSTOP:
               case OP_SELLLIMIT:
                  if(NormalizeDouble(modify_open_price - order_close_price,order_digits) < stoplevel) to_modify2 = false;
                  break;
              }
            if(!to_modify2)
              {
               error = false;
               break;
              }
           }
         if(new_expiration < 0 || new_expiration == order_expiration) double modify_expiration = order_expiration;
         else
           {
            modify_expiration = new_expiration;
            to_modify = true;
           }
         double second_price = modify_open_price;
        }
      else
        {
         modify_open_price = order_open_price;
         modify_expiration = order_expiration;
         second_price = order_close_price;
        }
      if(new_stop_loss < 0 || new_stop_loss == order_stop_loss) double modify_stop_loss = order_stop_loss;
      else
        {
         modify_stop_loss = new_stop_loss;
         to_modify = true;
        }
      if(new_take_profit < 0 || new_take_profit == order_take_profit) double modify_take_profit = order_take_profit;
      else
        {
         modify_take_profit = new_take_profit;
         to_modify = true;
        }
      if(!to_modify)
        {
         error = true;
         break;
        }
      if((order_type % 2) == OP_BUY)
        {
         if(modify_stop_loss != 0.0 && NormalizeDouble(second_price - modify_stop_loss,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
         if(modify_take_profit != 0.0 && NormalizeDouble(modify_take_profit - second_price,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
        }
      else
        {
         if(modify_stop_loss != 0.0 && NormalizeDouble(modify_stop_loss - second_price,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
         if(modify_take_profit != 0.0 && NormalizeDouble(second_price - modify_take_profit,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
        }
      for(int i=0; i<number_attempts_modify_wait; i++)
        {
         if(!IsTradeContextBusy()) break;
         Sleep(1000);
        }
      if(i >= number_attempts_modify_wait) continue;
      GetLastError();
      error = OrderModify(order_ticket,modify_open_price,modify_stop_loss,modify_take_profit,modify_expiration,order_color);
      if(!error)
        {
         int err = GetLastError();
         Print(StringConcatenate(parent_fun_name,"OrderModifyEx(",OrderTypeToStr(order_type),",",DoubleToStr(order_ticket,0),") error = ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               cont = true;
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               cont = true;
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_modify) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_modify) cont = true;
               break;
            case  134:
               Sleep(6000);
               cont = true;
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_modify) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_modify) cont = true;
               break;
            case  142:
               Sleep(70000);
               cont = true;
               break;
            case  143:
               Sleep(70000);
               cont = true;
               break;
            case  145:
               Sleep(20000);
               err_145++;
               if(err_145 <= number_attempts_modify) cont = true;
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case  147:
               new_expiration = 0;
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               cont = true;
               break;
           }
         if(!cont) break;
        }
      else break;
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderDeleteEx --------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool OrderDeleteEx(int order_ticket, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_delete        3
#define number_attempts_delete_select 3
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   int err_129 = 0;
   int err_130 = 0;
   int err_137 = 0;
   int err_138 = 0;
   while(true)
     {
      if(!IsExpertEnabled())
        {
         bool error = false;
         break;
        }
      RefreshRates();
      int counter_attempts_select = 0;
      while(counter_attempts_select < number_attempts_delete_select)
        {
         if(OrderSelect(order_ticket,SELECT_BY_TICKET)) break;
         Print(StringConcatenate(parent_fun_name,"OrderDeleteEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
         Sleep(1000);
         counter_attempts_select++;
        }
      if(counter_attempts_select >= number_attempts_delete_select)
        {
         error = false;
         break;
        }
      if(OrderCloseTime() != 0) 
        {
         error = true;
         break;
        }
      while(IsTradeContextBusy()) Sleep(1000);
      int order_type = OrderType();
      GetLastError();
      if(order_type <= OP_SELL) error = OrderClose(order_ticket,OrderLots(),OrderClosePrice(),slippage,order_color);
      else error = OrderDelete(order_ticket,order_color);
      if(!error)
        {
         int err = GetLastError();
         Print(StringConcatenate(parent_fun_name,"OrderDeleteEx(",OrderTypeToStr(order_type),",",DoubleToStr(order_ticket,0),") error = ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               cont = true;
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               cont = true;
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_delete) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_delete) cont = true;
               break;
            case  134:
               Sleep(6000);
               cont = true;
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_delete) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_delete) cont = true;
               break;
            case  142:
               Sleep(70000);
               cont = true;
               break;
            case  143:
               Sleep(70000);
               cont = true;
               break;
            case  145:
               Sleep(20000);
               cont = true;
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               cont = true;
               break;
           }
         if(!cont) break;
        }
      else break;
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderCloseEx ---------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool OrderCloseEx(int order_ticket, double order_lots, double order_close_price, int order_slippage, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_close           3
#define number_attempts_close_select    3
#define number_attempts_close_wait      30
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   int err_129 = 0;
   int err_130 = 0;
   int err_137 = 0;
   int err_138 = 0;
   while(true)
     {
      if(!IsExpertEnabled())
        {
         bool error = false;
         break;
        }
      RefreshRates();
      int counter_attempts_select = 0;
      while(counter_attempts_select < number_attempts_close_select)
        {
         if(OrderSelect(order_ticket,SELECT_BY_TICKET))
           {
            int order_digits = MarketInfo(OrderSymbol(),MODE_DIGITS);
            break;
           }
         Print(StringConcatenate(parent_fun_name,"OrderCloseEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
         Sleep(1000);
         counter_attempts_select++;
        }
      if(counter_attempts_select >= number_attempts_close_select)
        {
         error = false;
         break;
        }
      if(OrderCloseTime() != 0) 
        {
         error = true;
         break;
        }
      int order_type = OrderType();
      for(int i=0; i<number_attempts_close_wait; i++)
        {
         if(!IsTradeContextBusy()) break;
         Sleep(1000);
        }
      if(i >= number_attempts_close_wait) continue;
      RefreshRates();
      GetLastError();
      order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      error = OrderClose(order_ticket,order_lots,order_close_price,order_slippage,order_color);
      if(!error)
        {
         int err = GetLastError();
         Print(StringConcatenate(parent_fun_name,"OrderCloseEx(",OrderTypeToStr(order_type),",",DoubleToStr(order_ticket,0),") error = ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_close) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_close) cont = true;
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_close) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_close) cont = true;
               break;
            case  142:
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  143:
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  145:
               Sleep(20000);
               cont = true;
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
           }
         if(!cont) break;
        }
      else break;
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- CloseOrders ----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int CloseOrders(int cmd, int magic_number, string order_symbol = "")
  {
   if(order_symbol == "") order_symbol = symbol;
   int order_digits = MarketInfo(symbol,MODE_DIGITS);
   int num_errors = 0;
   int num_orders = 0;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         Print(StringConcatenate("CloseOrders: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(OrderSymbol() != order_symbol) continue;
      int order_type = OrderType();
      if(cmd == -4)
        {
         if((order_type % 2) != OP_BUY) continue;
        }
      else
        {
         if(cmd == -5)
           {
            if((order_type % 2) != OP_SELL) continue;
           }
         else
           {
            if(cmd == -3)
              {
               if(order_type <= OP_SELL) continue;
              }
            else
              {
               if(cmd == -2)
                 {
                  if(order_type > OP_SELL) continue;
                 }
               else
                 {
                  if(cmd >= OP_BUY)
                    {
                     if(order_type != cmd) continue;
                    }
                 }
              }  
           }
        }
      if(order_type <= OP_SELL)
        {
         if(order_type == OP_BUY) color order_color = ColorBuy;
         else order_color = ColorSell;
         bool error = OrderCloseEx(OrderTicket(),OrderLots(),NormalizeDouble(OrderClosePrice(),order_digits),slippage,order_color,"CloseOrders");
        }
      else error = OrderDeleteEx(OrderTicket());
      if(!error) num_errors--;
      else num_orders++;
     }
   if(num_errors != 0) return(num_errors);
   return(num_orders);
  }

//---------------------------------------------------------------------------------------------+
//---- WatchMoveSLToBE ------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool WatchMoveSLToBE(double be_profit, double be_offset, int magic_number)
  {
   bool result = true;
   int total = OrdersTotal() - 1;
   double stoplevel = NormalizeDouble(MarketInfo(symbol,MODE_STOPLEVEL)*Point,Digits);
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         Print(StringConcatenate("WatchMoveSLToBE: OrderSelect() error = ",ErrorDescription(GetLastError())));
         result = false;
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  Digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      if(order_type == OP_BUY)
        {
         double new_stop_loss = NormalizeDouble(order_open_price + be_offset,Digits);
         if(order_stop_loss >= new_stop_loss) continue;
         double order_profit = NormalizeDouble(order_close_price - order_open_price,Digits);
         color ColorMove = ColorBuy;
        }
      else
        {
         new_stop_loss = NormalizeDouble(order_open_price - be_offset,Digits);
         if(order_stop_loss != 0.0 && order_stop_loss <= new_stop_loss) continue;
         order_profit = NormalizeDouble(order_open_price - order_close_price,Digits);
         ColorMove = ColorSell;
        }
      if(order_profit <  be_profit) continue;
      if(order_profit <= stoplevel)
        {
         //if(WriteDebugLog) Print(StringConcatenate("WatchMoveSLToBE: ticket ",DoubleToStr(OrderTicket(),0)," - it is impossible to move, the level stop-loss is near to the close price."));
         continue;
        }
      bool error = OrderModifyEx(OrderTicket(),order_open_price,new_stop_loss,OrderTakeProfit(),0,ColorMove,"WatchMoveSLToBE");
      if(!error) result = false;
     }
   return(result);
  }

//---------------------------------------------------------------------------------------------+
//---- SetOrderLevels -------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void SetOrderLevels(double tp_points, double sl_points, int magic_number)
  {
   double stoplevel = NormalizeDouble(MarketInfo(symbol,MODE_STOPLEVEL)*Point,Digits);
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         Print(StringConcatenate("SetOrderLevels: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(OrderSymbol() != symbol) continue;
      int order_type = OrderType();
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      if(order_type > OP_SELL)
        {
         if(NormalizeDouble(MathAbs(order_open_price - order_close_price),Digits) <= stoplevel) continue;
        }
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  Digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),Digits);
      bool to_modify_sl = false;
      if(order_stop_loss == 0.0)
        {
         if(sl_points < 0.0)
           {
            if((order_type % 2) == OP_BUY)
              {
               double stoploss = NormalizeDouble(order_open_price + sl_points,Digits);
               if(order_type == OP_BUY)
                 {
                  if(NormalizeDouble(order_close_price - stoploss,Digits) > stoplevel) to_modify_sl = true;
                  else stoploss = order_stop_loss;
                 }
               else to_modify_sl = true;
              }
            else
              {
               stoploss = NormalizeDouble(order_open_price - sl_points,Digits);
               if(order_type == OP_SELL)
                 {
                  if(NormalizeDouble(stoploss - order_close_price,Digits) > stoplevel) to_modify_sl = true;
                  else stoploss = order_stop_loss;
                 }
               else to_modify_sl = true;
              }
           }
         else stoploss = order_stop_loss;
        }
      else stoploss = order_stop_loss;
      bool to_modify_tp = false;
      if(order_take_profit == 0.0)
        {
         if(tp_points > 0.0)
           {
            if((order_type % 2) == OP_BUY)
              {
               double takeprofit = NormalizeDouble(order_open_price + tp_points,Digits);
               if(order_type == OP_BUY)
                 {
                  if(NormalizeDouble(takeprofit - order_close_price,Digits) > stoplevel) to_modify_tp = true;
                  else takeprofit = order_take_profit;
                 }
               else to_modify_tp = true;
              }
            else
              {
               takeprofit = NormalizeDouble(order_open_price - tp_points,Digits);
               if(order_type == OP_SELL)
                 {
                  if(NormalizeDouble(order_close_price - takeprofit,Digits) > stoplevel) to_modify_tp = true;
                  else takeprofit = order_take_profit;
                 }
               else to_modify_tp = true;
              }
           }
         else takeprofit = order_take_profit;
        }
      else takeprofit = order_take_profit;
      if(to_modify_sl || to_modify_tp)
        {
         if((order_type % 2) == OP_BUY) color order_color = ColorBuy;
         else order_color = ColorSell;
         OrderModifyEx(OrderTicket(),order_open_price,stoploss,takeprofit,0,order_color,"SetOrderLevels");
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- WatchOrderLevels -----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void WatchOrderLevels(double tp_value, double sl_value, int magic_number)
  {
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         Print(StringConcatenate("WatchOrderLevels: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(OrderSymbol() != symbol) continue;
      double order_close_price = NormalizeDouble(OrderClosePrice(),Digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), Digits);
      if(order_type == OP_BUY)
        {
         double profit = NormalizeDouble(order_close_price - order_open_price,Digits);
         color order_color = ColorBuy;
        }
      else
        {
         profit = NormalizeDouble(order_open_price - order_close_price,Digits);
         order_color = ColorSell;
        }
      if(tp_value > 0.0 && profit >= tp_value)
        {
         Print("WatchOrderLevels: closing by level t/p.");
         OrderCloseEx(OrderTicket(),OrderLots(),order_close_price,slippage,order_color,"WatchOrderLevels");
        }
      else
        {
         if(sl_value < 0.0 && profit <= sl_value)
           {
            Print("WatchOrderLevels: closing by level level s/l.");
            OrderCloseEx(OrderTicket(),OrderLots(),order_close_price,slippage,order_color,"WatchOrderLevels");
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- GetIndicatorSignal ---------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
void GetIndicatorSignal(int& current_trend, int& new_trend, int shift)
  {
   double tma_value = iCustom(symbol,0,IndicatorName_TMA,TMA_eintPeriod,TMA_edblHigh1,TMA_edblLow1,TMA_atrPeriod,false,White,1,25,3,14,11,1,1,3,6,shift);
   current_trend = 0;
   new_trend     = 0;
   if(tma_value >= TMA_edblHigh1)
     {
      current_trend++;
      if(last_alert_trend <= 0)
        {
         last_alert_trend = 1;
         new_trend++;
        }
     }
   else   // "else"     
     {
      if(tma_value <= TMA_edblLow1)
        {
         current_trend--;
         if(last_alert_trend >= 0)
           {
            last_alert_trend = -1;
            new_trend--;
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- WatchCloseBy ---------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void WatchCloseBy(int magic_number, int magic_number_closeby)
  {
   while(true)
     {
      if(IsStopped()) break;
      Sleep(1000);
      RefreshRates();
      //----    --------------------------------------------------------+
      int ticket_closeby  = -1;
      int type_closeby    = 0;
      double lots_closeby = 0.0;
      int total = OrdersTotal() - 1;
      for(int i=total; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           {
            Print("WatchCloseBy_1: OrderSelect() error = ",ErrorDescription(GetLastError()));
            continue;
           }
         int order_type = OrderType();
         if(order_type > OP_SELL) continue;
         if(OrderMagicNumber() != magic_number_closeby) continue;
         if(OrderSymbol() != symbol) continue;
         ticket_closeby = OrderTicket();
         type_closeby   = order_type;
         lots_closeby   = NormalizeDouble(OrderLots(),lots_digits);
         break;
        }
      //----    ,   -----------------------------------------+
      if(ticket_closeby < 0) break;
      //----    --------------------------------------------------------+
      int type_main = MathAbs(type_closeby - 1);
      int ticket_main  = -1;
      double lots_main = 0.0;
      total = OrdersTotal() - 1;
      for(i=total; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
           {
            Print("WatchCloseBy_2: OrderSelect() error = ",ErrorDescription(GetLastError()));
            continue;
           }
         if(OrderType() != type_main) continue;
         if(OrderMagicNumber() != magic_number) continue;
         if(OrderSymbol() != symbol) continue;
         ticket_main = OrderTicket();
         lots_main   = NormalizeDouble(OrderLots(),lots_digits);
         break;
        }
      //----    ,        --------------+
      if(ticket_main < 0)
        {
         if(OrderCloseEx(ticket_closeby,lots_closeby,0.0,slippage,Aqua,"WatchCloseBy")) break;
        }
      //----     ------------------------------------------------------+
      else
        {
         if(lots_closeby > lots_main)
           {
            while(!IsTradeAllowed()) Sleep(1000);
            bool error = OrderCloseBy(ticket_main,ticket_closeby,Aqua);
            if(!error) Print("WatchCloseBy: OrderCloseBy(",DoubleToStr(ticket_main,0),",",DoubleToStr(ticket_closeby,0),") error = ",ErrorDescription(GetLastError()));
           }
         else
           {
            while(!IsTradeAllowed()) Sleep(1000);
            error = OrderCloseBy(ticket_closeby,ticket_main,Aqua);
            if(!error) Print("WatchCloseBy: OrderCloseBy(",DoubleToStr(ticket_closeby,0),",",DoubleToStr(ticket_main,0),") error = ",ErrorDescription(GetLastError()));
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- GetOpenedLots --------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
double GetOpenedLots(int cmd, int magic_number)
  {
   double gross_lots = 0.0;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         Print("GetOpenedLots: OrderSelect() error = ",ErrorDescription(GetLastError()));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(cmd >= 0) if(OrderType() != cmd) continue;
      if(OrderSymbol() != symbol) continue;
      gross_lots += OrderLots();
     }
   gross_lots = NormalizeDouble(gross_lots,lots_digits);
   return(gross_lots);
  }

//---------------------------------------------------------------------------------------------+